Alexandria is a library of useful code and various APIs with the intention of simplifying the mod creation process via it's use as a dependency.

## Featured APIs
1. CharAPI
2. ChestAPI (heavily wip and is largely useless atm)
3. DungeonAPI (formerly GungeonAPI)
4. EnemyAPI
5. ItemAPI
6. NPCAPI
7. PrefabAPI
8. TranslationAPI

## Change Log

0.2.11
Bugfixes:
- Fixed an issue where goop just didnt work at all

0.2.10
Bugfixes:
- Fixed an issue where the mod wouldnt load

0.2.9
Significant Changes:
- Added a new class called GoopUtility, which contains static references to all vanilla goop types, as well as the utility necessary for creating custom goops.

Bugfixes:
- Fixed an issue where rage effects triggered through Alexandria would cause an error.
- Fixed an issue where invulnerability effects triggered through Alexandria would never end.
- Fixed an issue where Alexandria would cause errors with spapi's singleplayer cultist.

0.2.8
- Added an emergency fix for instances where the extended player component is checked for before it has been added.

0.2.7
Significant Changes:
- Added the following actions to ExtendedPlayerComponent; OnBlankModificationItemProcessed, OnNewOrbitalInitialised.

Minor Changes:
- Removed unecessary console logging.
- Fixed OnPickedUpHP actions not triggering.

0.2.6
Significant Changes:
- Added a Vector2 extension called GetPositionOfNearestEnemy which returns the Vector2 position of the closest enemy to the initial position.
- Added MasteryOverrideHandler under the DungeonAPI namespace. MasteryOverrideHandler contains the method 'RegisterFloorForMasterySpawn', which allows users to tell Alexandria that one of the three viable secret floors (Oub, Abbey, or R&G) should spawn a master round (namely the Keep master round).
- Added the 'OnRewardPedestalDetermineContents' action to CustomActions. This runs whenever a reward pedestal goes to calculate it's item, and allows those who subscribe to it to add item ids and weights to a list which will be converted into an override item pool for the pedestal. Ideal for those looking to add new master rounds or change boss rewards.

Minor Changes:
- Added the following actions to ExtendedPlayerComponent; OnCompanionSpawnedBullet, OnCompanionStatsQueried, and OnPickedUpBlank.
- Added the following actions to CustomActions; OnRatMazeFailed, OnLOTJSpawned, and OnAnyPlayerCollectedBlank.
- Added XML comments for the actions in ExtendedPlayerComponent and CustomActions.
- Added a GetVectorToNearestEnemy extension to Vector2 for easier shorthand.
- Fixed an issue where ImprovedHelixProjectile was not public.
- Improved the OnRunStart action with the help of SomeBunny to function effectively on shortcuts.
- Removed duplicate RecalculateOrbitals method in OrbitalUtility.

0.2.5
Significant Changes:
- None

Minor Changes:
- Fixed an exception in CustomActions caused by a hook not being static.
- Added an 'excludedActors' list to all GetNearestEnemyToPosition methods to allow the easy exclusion of specific AIActors.
- Fixed a capitalisation issue in the ChestAPI namespace.

0.2.4
Significant Changes:
- Added the CustomDiscountController, a system for designing dynamic, intelligent shop discounts.
- Added the following Actions to CustomActions; OnAnyPlayerCollectedAmmo, OnAnyPlayerCollectedKey, OnAnyPlayerCollectedHealth, OnShopItemStarted, and OnAnyPlayerNudgedHealth.
- Added the following Actions to ExtendedPlayerComponent; OnActiveItemPreDrop, OnPickedUpAmmo, OnPickedUpKey, OnPickedUpHP, and OnNudgedHP.
- Added a ShadowBulletDoer, for simpler triggering of shadow bullet/pop-pop style bullet chain effects.
- Added an ImprovedHelixProjectile projectile type, for the creation of simpler default helix motion bullets.
- Added XML comments for methods in the following classes; ProjectileUtility, AIActorUtility, AlexandriaTags, MathAndLogicExtensions, PlayerUtility, and ExtendedPlayerComponent.
- Added ChestUtility, which is NOT a toolbox for making chests, but contains a number of useful methods for spawning existing chest types, performing actions on existing chests at runtime.
- Added an interface called ILabelItem, which allows the user to set a custom string label that should be displayed in the corner of the active item slot.
- Added 'GameManagerUtility', a class containing extension methods relating to global things such as checking both playercontrollers.
- Added 'RuntimeRoomhandlerUtility', a class containing extension methods relating to room handlers. Only relates to roomhandlers at runtime, and is NOT related to room setup.

Minor Changes:
- Made TrailAPI & EnumUtility public.
- Added extension methods for MakeFakePrefab and InstantiateAndFakePrefab.
- Reimplemented the 'AddProjectileModuleToRawVolleyFrom' method into GunTools.
- Performed general code maintenance on; BeamAPI, and ExtendedPlayerComponent.
- Added an extension method to AIActorUtility which triggers a genie punch on the AIActor, an extension method which searches for a given DirectionalAnimation on the AIAnimator, and an extension method for more easily transmogrifying given enemies, with more control over the parameters and outcome.
- Added an extension method to AlexandriaTags which allows to user to easily check if an actor has any of the given tags in a list.

0.2.3
1. today i will forget to test my code before uploading

0.2.2
1. got angry and ripped out the sprite handler add animation methods coz they where useless 
2. some other shit thats probably important

0.2.1
1. i litterally have no clue

0.2.0
1. updated Chamber Gun API
2. fixed a bunch of bugs
3. updated dungeon api so it can load room from the upcoming RAT update
4. updated NPCAPI to allow for true custom npc creation outside of shops
5. probably other shit idk

0.1.3:
1. fixed issues with references causing a lot of things to break

0.1.2:
1. im a dumbass and fucked up the file setup

0.1.1: 
1. fixed an issue where some projectile sprites wouldn't show up correctly in game
2. fixed an issue where `CustomActions` was private

0.1.0:
1. initial releases